#ifndef MAINWINDOW_H
#define MAINWINDOW_H


//#include "mysql.h"

#include <QMainWindow>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QTreeWidgetItem>
#include <QTextCodec>
#include <QSqlDatabase>

#include <QtGui>
#include <QString>
#include <QtSql>
#include <QFont>
#include <QColor>


/*
#include <QSqlField>
#include <QSqlRecord>
#include <QSqlTableModel>
#include <QSqlQueryModel>
#include <QTableView>
#include <QSqlDriverPlugin>
#include <QIcon>
#include <QVariant>
#include <QProcess>
#include <QByteArray>
*/

typedef struct Class {
        QString name;
        QString ID;

} TClass;




namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;

    QList<QTreeWidgetItem *> root_items_list;
    QStandardItemModel *model;
    QStandardItem *item;
    QTreeWidgetItem *rootItem1, *rootItem2;
    void openBase();
    bool readModel();
    void setupModelData(const QStringList &lines, QTreeWidgetItem *parent);
    void creatModelString();
    QString modelString; // ,   
    void addChildsString(QTreeWidgetItem *parentItem, int level);

    QSqlDatabase sql;
    bool model_is_build; //  ,    (true)    (false)

    bool openDataBase();
    bool buildPreviewModel(QString modelName, QString rootClassID);

    bool rebuildPreviewModel(QTreeWidgetItem* root_item, QString rootClassID);

    QString ClassName(QString class_id); //     ID
    void addChildsItems(QTreeWidgetItem *perent_class_item); //          ,      
    QStringList classChields(QString class_id);
    QMap <QString, QString> getClassList(); //   
    void initComboBox();
    QList<QTreeWidgetItem *> rootItems; //     ()
    QSqlTableModel * sql_mogel;
    int pointer_index; // -   
    QString parentObject_id;


    QMap <QString, QString> class_list_map;
    void getDatabaseData();
    void buildTree(QTreeWidgetItem * model_item);
    QString getClassInctance(QString class_id); //    -   
    void showClassObjects(QTreeWidgetItem * parent_item, QTreeWidgetItem * model_item); //   
    void showObjectChildrens(QString object_ID, QTreeWidgetItem * object_item, QTreeWidgetItem * model_item); //   
    void showObjects(QTreeWidgetItem * parent_object_item, QTreeWidgetItem * model_item, QString filtr);// //   
    QString getPointerFieldName(QString parent_class_id, QString chield_class_id); //   ,        




private slots:
    void on_comboBox_currentIndexChanged( int index );
    void on_treeWidget_itemChanged ( QTreeWidgetItem * item, int column );
    void on_treeWidget_itemClicked ( QTreeWidgetItem * item, int column );
    void on_treeWidget_2_itemClicked ( QTreeWidgetItem * item, int column );
    void on_pushButton_clicked(); //   " "
    void on_pushButton_2_clicked();//   "  "
    void on_pushButton_3_clicked();//   ""
    void on_pushButton_4_clicked();//   " "
    void on_sql_mogel_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ); //       

};




#endif // MAINWINDOW_H
